#!/bin/sh
# get_tsc_config.sh $LOG_PATH $LOG_FILE_NAME

target_ip="10.100.250.137"
host_ip="10.100.250.132"
sys_log=$1"/"$2

echo "########################################################################" >> $sys_log
echo "#                  SPC-1 TSC Environment Check Script                  #" >> $sys_log
echo "#                      Created by Gluesys Co.,Ltd.                     #" >> $sys_log
echo "########################################################################" >> $sys_log

echo "" >> $sys_log
echo "" >> $sys_log
echo "" >> $sys_log
echo "Get host information." >> $sys_log
echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
cat /etc/os-release >> $sys_log
echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
uname -r >> $sys_log
echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
lsblk -b >> $sys_log
echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
fdisk -l >> $sys_log
echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
pvs --units G >> $sys_log
echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
vgs --units G >> $sys_log
echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
lvs --units G -v --segment >> $sys_log
echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log

echo "" >> $sys_log
echo "" >> $sys_log
echo "" >> $sys_log
echo "Get Host-Disk parameter." >> $sys_log

for ip in $host_ip;
do
	devs=$(ssh root@$ip 'egrep MR9361-8i /sys/block/sd?/device/model' | awk -F '/' '{print $4}')

	echo =====================$ip===================== >> $sys_log

	for dev in $devs;
	do
		echo +++++++++++++++/dev/$dev+++++++++++++++ >> $sys_log
		#devices configuration setup
		echo -n 'nr_requests : ' >> $sys_log
		ssh root@$ip cat /sys/block/$dev/queue/nr_requests >> $sys_log
		echo -n 'scheduler : ' >> $sys_log
		ssh root@$ip cat /sys/block/$dev/queue/scheduler >> $sys_log
		echo -n 'nomerges : ' >> $sys_log
		ssh root@$ip cat /sys/block/$dev/queue/nomerges >> $sys_log
		echo -n 'add_random : ' >> $sys_log
		ssh root@$ip cat /sys/block/$dev/queue/add_random >> $sys_log
		echo -n 'rq_affinity : ' >> $sys_log
		ssh root@$ip cat /sys/block/$dev/queue/rq_affinity >> $sys_log

	done
	#OS configuration setup
	echo '+++++++++++++++system parameter+++++++++++++++' >> $sys_log
	echo -n 'aio-max-nr : '	>> $sys_log
	echo '----------------------------------------------' >> $sys_log
	ssh root@$ip cat /proc/sys/fs/aio-max-nr >> $sys_log
	echo 'ulimit -a' >> $sys_log
	ssh root@$ip ulimit -a >> $sys_log
	echo '----------------------------------------------' >> $sys_log
	echo 'ulimit -aH' >> $sys_log
	ssh root@$ip ulimit -aH >> $sys_log
done

echo "" >> $sys_log
echo "" >> $sys_log
echo "" >> $sys_log
echo "Get Storage-Disk information.(smartctl)" >> $sys_log

for ip in $target_ip;
do
	echo ====================$ip================= >> $sys_log
	devs=$(ssh root@$ip 'ls /dev/sd[b-m]')
	for dev in $devs
	do
		echo +++++++++++++++++++++$dev++++++++++++++++++ >> $sys_log
        	ssh root@$ip smartctl -a $dev >> $sys_log
	done
done

echo "" >> $sys_log
echo "" >> $sys_log
echo "" >> $sys_log
echo "Get Storage-RAID information." >> $sys_log

for ip in $target_ip;
do
	echo ====================$ip================= >> $sys_log
	ssh root@$ip megacli -ShowSummary -aALL >> $sys_log
done

echo "" >> $sys_log
echo "" >> $sys_log
echo "" >> $sys_log
echo "Get Storage-Disk parameter." >> $sys_log

for ip in $target_ip;
do
	devs=$(ssh root@$ip 'egrep iser /sys/block/sd?/device/model' | awk -F '/' '{print $4}')

	echo =====================$ip===================== >> $sys_log

	for dev in $devs;
	do
		echo +++++++++++++++/dev/$dev+++++++++++++++ >> $sys_log
		#devices configuration setup
                echo -n 'nr_requests : ' >> $sys_log
                ssh root@$ip cat /sys/block/$dev/queue/nr_requests >> $sys_log
                echo -n 'scheduler : ' >> $sys_log
                ssh root@$ip cat /sys/block/$dev/queue/scheduler >> $sys_log
                echo -n 'nomerges : ' >> $sys_log
                ssh root@$ip cat /sys/block/$dev/queue/nomerges >> $sys_log
                echo -n 'add_random : ' >> $sys_log
                ssh root@$ip cat /sys/block/$dev/queue/add_random >> $sys_log
                echo -n 'rq_affinity : ' >> $sys_log
                ssh root@$ip cat /sys/block/$dev/queue/rq_affinity >> $sys_log
	done
	#OS configuration setup
	echo '+++++++++++++++system parameter+++++++++++++++' >> $sys_log
	echo -n 'aio-max-nr : '	>> $sys_log
	ssh root@$ip cat /proc/sys/fs/aio-max-nr >> $sys_log
	echo '----------------------------------------------' >> $sys_log
	echo 'ulimit -a' >> $sys_log
	ssh root@$ip ulimit -a >> $sys_log
	echo '----------------------------------------------' >> $sys_log
	echo 'ulimit -aH' >> $sys_log
	ssh root@$ip ulimit -aH >> $sys_log
done
